<?php

namespace Drupal\xray_audit\Plugin;

use Drupal\Component\Plugin\PluginBase;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 * Base class for xray_audit_task_plugin plugins.
 */
abstract class XrayAuditTaskPluginBase extends PluginBase implements XrayAuditTaskPluginInterface, ContainerFactoryPluginInterface {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function label() {
    // Cast the label to a string since it is a TranslatableMarkup object.
    return (string) $this->pluginDefinition['label'];
  }

  /**
   * {@inheritdoc}
   */
  public function getGroup() {
    return $this->pluginDefinition['group'];
  }

  /**
   * {@inheritdoc}
   */
  public function getDescription() {
    // Cast the label to a string since it is a TranslatableMarkup object.
    return (string) $this->pluginDefinition['description'];
  }

  /**
   * {@inheritdoc}
   */
  public function getSort() {
    return $this->pluginDefinition['sort'];
  }

  /**
   * {@inheritdoc}
   */
  public function getOperations() {
    return $this->pluginDefinition['operations'] ?? [];
  }

  /**
   * {@inheritdoc}
   */
  public function getBatchClass(string $batch_id) {
    return $this->pluginDefinition['batches'][$batch_id] ?? NULL;
  }

}
